#ifndef _SUFLIB_
#define _SUFLIB_
#include "token.h"

#define POLY_SEPARATER -1
/*readsuf.h*/
class Object {
public:
	char	name[16];
	char	*filename;
	int		maxx, minx;
	int		maxy, miny;
	int		maxz, minz;
	int		*point_x;
	int		*point_y;
	int		*point_z;
	int		*line_1;
	int		*line_2;
	int		points;
	int		lines;

	int		*polypoint;
	int 	*poly;
	int		polypoints, polys;

	int		polygons;

	Object(TokenReader*);
	Object();
	~Object();
	int Succeed(void);
	Object *Copy(void);
	void Delete(void);
	static void UsePoly(void);
	static int IsPoly(void);
private:
//	static int usepoly = FALSE;
	int copy;
	int allocpoints, alloclines, allocpolys, allocpolypoints;
	void lineset( int, int );
	void polypointset(int);
	void polyset(int);
	int point( int, int, int );
	void readpoly(TokenReader*);
};


static const int MaxObject = 32;
class SufFile {
private:
//	static SufFile *top = NULL;
	SufFile *next;
public:
	char	filename[128];
	Object *object[MaxObject];

	static Object *OpenObject(char *fname, char *oname = NULL);
	static SufFile *OpenSuf( char *fname );
	SufFile(char *filename);
	~SufFile();
};

#endif
